/* Code style: -*- linux-c -*- */
/* File : xfw/premptive.c */

#include <forms.h>
#include "xfw.h"

#define TIMEOUT 0
#define DELAY 1

/* ok I need another set of 'global' locals ( f**k ) and prototype */

double elapse=DELAY;

void countdown_cb(FL_OBJECT *ob, long delay)
{
  if (elapse == TIMEOUT)
    fl_set_timer(timer, delay);

  elapse = fl_get_timer(timer);
}


void setup_preemptives(void)
{
  /* attach preemptives to objects */
  
  fl_set_object_prehandler(delete, preemptive_handler);
  fl_set_object_posthandler(append, preemptive_handler);
  fl_set_object_posthandler(add, preemptive_handler);
  fl_set_object_posthandler(replace, preemptive_handler);
  
}


int preemptive_handler(FL_OBJECT *ob, int event, FL_Coord mx, FL_Coord my, int key, void *xev)
{
  char *s = 0;
  
  /* some 'expensive' code here, but again it's all for the better glory 8) */
  
  if (event == FL_ENTER)
     countdown_cb(ob, elapse);

  if (elapse < 0.2 ) {

  if (ob == delete) {
    if (!fl_get_button(ob))
      s = "Click twice to delete\nhighlighted entry";
  }
  
  if (ob == append) {
    if (!fl_get_button(ob))
      s = "Insert entry under\ncurrent highlight";
  }

  if (ob == add) {
    if(!fl_get_button(ob))
      s = "Add a firewall entry";
  }

  if (ob == replace) {
    if (!fl_get_button(ob))
      s = "Overwrite the highlighted\nentry with entry bar contents";
  }
  
  /* all objects have x, y information in their structures, grab it */
  if (event == FL_ENTER && s)
    fl_show_oneliner(s, ob->form->x + ob->x,
		     ob->form->y + ob->y + ob->h + 5);
  if (event == FL_LEAVE && s) {
    fl_hide_oneliner();
    elapse = DELAY;
  }

  }
  
  return(0); /* I was going to put in some error code checking, honest */
}
